// generated by ../deps/sqlpp11/scripts/ddl2cpp ranks.sqlpp11.sql ranks wee
#ifndef WEE_RANKS_H
#define WEE_RANKS_H

#include <sqlpp11/table.h>
#include <sqlpp11/data_types.h>
#include <sqlpp11/char_sequence.h>

namespace wee
{
  namespace Ranks_
  {
    struct Id
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "id";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T id;
            T& operator()() { return id; }
            const T& operator()() const { return id; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::must_not_insert, sqlpp::tag::must_not_update>;
    };
    struct Name
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "name";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T name;
            T& operator()() { return name; }
            const T& operator()() const { return name; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::text, sqlpp::tag::require_insert>;
    };
    struct Order
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "!order";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T order;
            T& operator()() { return order; }
            const T& operator()() const { return order; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::require_insert>;
    };
    struct Permissive
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "permissive";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T permissive;
            T& operator()() { return permissive; }
            const T& operator()() const { return permissive; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::boolean, sqlpp::tag::require_insert>;
    };
  } // namespace Ranks_

  struct Ranks: sqlpp::table_t<Ranks,
               Ranks_::Id,
               Ranks_::Name,
               Ranks_::Order,
               Ranks_::Permissive>
  {
    struct _alias_t
    {
      static constexpr const char _literal[] =  "ranks";
      using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
      template<typename T>
      struct _member_t
      {
        T ranks;
        T& operator()() { return ranks; }
        const T& operator()() const { return ranks; }
      };
    };
  };
} // namespace wee
#endif
